      .486
      .model flat, stdcall
      option casemap :none

      include \masm32\include\windows.inc
      include \masm32\include\user32.inc
      include \masm32\include\kernel32.inc
      include \masm32\include\masm32.inc
      include \masm32\macros\macros.asm
      includelib \masm32\lib\masm32.lib
      includelib \masm32\lib\user32.lib
      includelib \masm32\lib\kernel32.lib

      szlen PROTO :DWORD
                  
.data
      string      db "Hello World!",0
      substring   db SIZEOF string dup(0)

      buffer      db 20 dup(0) 
.code
start:
      ; For STDCALL, the arguments are pushed in
      ; reverse order (right-most pushed first).

      push  5                 ; <length_of_substring>      
      push  7                 ; <base_1_start_position>      
      push  OFFSET substring  ; <address_of_substring>      
      push  OFFSET string     ; <address_of_string>
      call Mid$

      ; print is a MASM32 macro that displays text
      ; on the screen.      
      print ADDR substring
      ; SADD is a MASM32 macro that returns the
      ; address of its argument in ADDR name format.
      print SADD(13,10)

      push  0                 ; <length_of_substring>
      push  2                 ; <base_1_start_position>
      push  OFFSET substring  ; <address_of_substring>
      push  OFFSET string     ; <address_of_string>
      call Mid$

      print ADDR substring
      print SADD(13,10)

      invoke szlen,ADDR string
      invoke dw2a,eax,ADDR buffer
      print ADDR buffer
      print SADD(13,10)      

      print SADD(13,10,"Press enter to exit...",13,10)
      invoke StdIn,addr buffer,1
      exit

; For compatibility with Windows, procedures that will
; be called by Windows must preserve EBP, EBX, EDI,
; and ESI, and a good convention would be to preserve
; these registers for all procedures.
;
; All strings are null terminated.

; 
; The is a MASM procedure that does essentially what
; the VB Mid$ function does, with everything coded
; manually. To keep it as simple as possible, the 
; caller is responsible for allocating storage for
; the substring. A value of zero for the length of
; the substring indicates that the substring should
; include all characters from the start position to
; the end of the string.
;
; The parameters are:
;     address_of_string:DWORD
;     address_of_substring:DWORD
;     base_1_start_position:DWORD
;     length_of_substring:DWORD
; 
Mid$:
      ; Preserve EBP.
      push  ebp
      ; Prepare EBP for use as a stack frame pointer.
      mov   ebp,esp
      ;
      ; To allocate local data, you would subtract the
      ; total byte size of the local data from ESP
      ; here. The local data could then be accessed
      ; using negative offsets from EBP, with the
      ; first item at [EBP-4].
      ;
      ; Preserve EDI and ESI.
      push  edi
      push  esi
      ; Set ESI to <address_of_string>.
      mov   esi,[ebp+8]
      ; Add <base_1_start_position> to ESI.
      add   esi,[ebp+16]
      ; Adjust ESI for base 1.
      sub   esi,1
      ; Set EDI to <address_of_substring>.
      mov   edi,[ebp+12]
      ; Set ECX to <length_of_substring>.
      mov   ecx,[ebp+20]
      ; Test for zero length.
      cmp   ecx,0
      jne   notZero
      ; Set ECX to the length from the start
      ; position to the end of the string.
      push  [ebp+8]        ; <address_of_string>
      call  szlen          ; Get length into EAX.
      sub   eax,[ebp+16]   ; <base_1_start_position>
      add   eax,1
      mov   ecx,eax
   notZero:
      ; Clear direction flag so MOVSB will increment
      ; EDI and ESI after each byte is moved.
      cld
      ; Move the bytes.
      rep   movsb
      ; Append a terminating null to the substring.
      mov   byte ptr[edi],0
      ; Recover  EDI and ESI, poping them in the
      ; reverse of the order they were pushed.
      pop   esi
      pop   edi
      ; Next 2 instruction are equivalent to LEAVE.
      ;
      ; Restore ESP to the value is had after we
      ; preserved EBP. Although not necessary for
      ; this procedure, this would be absolutely
      ; necessary had we allocated local data.
      mov   esp,ebp
      ; Recover EBP.
      pop   ebp
      ; ESP now contains the same value it contained at
      ; procedure entry, so the RET instruction will
      ; correctly pop the return address from the stack.
      ; 
      ; Return to the caller and add the total byte
      ; length of the parameters (4*4) to ESP to
      ; restore the stack to the state it was in
      ; before the call.
      ret   16

; 
; This proc returns the length of the specified null-terminated
; string in EAX. The length does not include the terminator.
;
; Three benefits of defining a procedure with the PROC directive
; are that the parameters can be accessed by name, the proper
; stack adjustment on the RET instruction is automatic, and with
; an appropriate PROTO the procedure can be called with INVOKE.
; 
szlen proc lpsz:DWORD
      mov   eax,lpsz
   runLoop:
      ; Compare bytes until find null.
      cmp   byte ptr[eax],0
      jz    atEnd
      inc   eax
      jmp   runLoop
   atEnd:
      ; Calc length and return in EAX.
      sub   eax,lpsz
      ret
szlen endp
            
end start
